using System;

namespace nesusedni
{
    class Program
    {
        static void Main(string[] args)
        {
            long n = long.Parse(Console.ReadLine());
            string[] unos = Console.ReadLine().Split();
            int o = int.Parse(unos[0]);
            int a = int.Parse(unos[1]);
            int b = int.Parse(unos[2]);
            int ab = int.Parse(unos[3]);
            string [] niz = new string[n];
            int pom0 = 0;
            int poma = 0;
            int pomb = 0;
            int pomab = 0;
            int br = 0;
            for(int i = 0; i < n; i++)
            {
                pom0 = 0;
                poma = 0;
                pomb = 0;
                pomab = 0;
                string[] unosimo = Console.ReadLine().Split();
                int j = int.Parse(unosimo[1]);
                while (j > 0)
                {
                    if (unosimo[0] == "A")
                    {

                        if (a>0)
                        {
                            poma++;
                            a --;
                        }
                        else if (o>0)
                        {
                            pom0++;
                            o --;
                        }
                    }
                    else if (unosimo[0] == "B")
                    {
                        if (b>0)
                        {
                            pomb++;
                            b --;
                        }
                        else if (o>0)
                        {
                            pom0++;
                            o--;
                        }
                    }
                    else if (unosimo[0] == "AB")
                    {
                        if (ab>0)
                        {
                            pomab++;
                            ab --;
                        }
                        else if (o>0)
                        {
                            pom0++;
                            o --;
                        }
                        else if (a>0)
                        {
                            poma++;
                            a --;
                        }
                        else if (b>0)
                        {
                            pomb++;
                            b--;
                        }
                    }
                    else if (unosimo[0] == "O")
                    {
                        if (o>0)
                        {
                            pom0++;
                            o --;
                        }
                    }
                    j--;
                }
                if ((pom0 == 0) && (poma == 0) && (pomb == 0) && (pomab == 0))
                {
                    br++;
                }
                else
                {
                    niz[i] = (Convert.ToString(pom0)) + " " + (Convert.ToString(poma)) + " " + (Convert.ToString(pomb)) + " " + (Convert.ToString(pomab));
                }
            }
            if (br == 0)
            {
                string izlaz = "moguce";
                Console.WriteLine(izlaz);
                for (int c = 0; c < n; c++)
                {
                    Console.WriteLine(niz[c]);
                }
            }
            else
            {
                string izlaz = "nemoguce";
                Console.WriteLine(izlaz);
            }  
        }
    }
}